<?php

function dump(iterable $list)
{
    foreach ($list as $value) {
        echo $value;
    }
}

// arrayはiterable
dump([1, 2, 3]);

class TraversalClass implements Iterator
{
    private array $values;
    private int $index;

    public function __construct(array $values)
    {
        $this->values = array_values($values);
        $this->index = 0;
    }

    public function current()
    {
        return $this->values[$this->index];
    }

    public function next(): void
    {
        $this->index++;
    }

    public function key(): int
    {
        return $this->index;
    }

    public function valid(): bool
    {
        return isset($this->values[$this->index]);
    }

    public function rewind(): void
    {
        $this->index = 0;
    }
}

// traversalもiterable
dump(new TraversalClass([4, 5, 6]));

// arrayでもtraversalでもないのでTypeError
dump(new class() {});
