<?php

function myEach($array, $function)
{
    // $arrayは配列でないといけない
    if (!is_array($array)) {
        throw new InvalidArgumentException();
    }
    if (!$function instanceof Closure) {
        // $functionは関数名でないといけない
        if (!is_string($function)) {
            throw new InvalidArgumentException();
        }
        // $functionは定義されていないといけない
        if (!function_exists($function)) {
            throw new InvalidArgumentException();
        }
    }

    foreach ($array as $key => $value) {
        $function($value, $key);
    }
}
