<?php

class Age
{
    private int $value;

    public function __construct(int $value)
    {
        if ($value < 0 || $value > 120) {
            throw new InvalidArgumentException();
        }

        $this->value = $value;
    }

    public function getValue(): int
    {
        return $this->value;
    }

    // 引数はAgeしか受け付けないので、
    // intを含めほかの型とは比較できない
    public function isOlderThan(Age $another): bool
    {
        return $this->value > $another->value;
    }
}

function getOlder(Age $one, Age $another): Age
{
    return $one->isOlderThan($another) ? $one : $another;
}
